<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- moduleprovider.qdoc -->
  <title>ModuleProvider QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="qml-qbslanguageitems-module.html" />
  <link rel="next" href="qml-qbslanguageitems-parameter.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="qml-qbslanguageitems-module.html">Module</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-parameter.html">Parameter</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">ModuleProvider QML Type</h1>
<span class="subtitle"></span>
<!-- $$$ModuleProvider-brief -->
<p>Creates modules on demand. <a href="#details">More...</a></p>
<!-- @@@ModuleProvider -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsLanguageItems .</td></tr></table></div><ul>
<li><a href="qml-qbslanguageitems-moduleprovider-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbslanguageitems-moduleprovider.html#name-prop">name</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-moduleprovider.html#outputBaseDir-prop">outputBaseDir</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-moduleprovider.html#relativeSearchPaths-prop">relativeSearchPaths</a></b></b> : stringList</li>
</ul>
<!-- $$$ModuleProvider-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>The <code>ModuleProvider</code> item implements the module creation part of the procedure described in the <a href="module-providers.html">Module Providers</a> overview. It is always located in a file called <code>provider.qbs</code>.</p>
<p>The actual module creation is done on the right-hand side of the <a href="qml-qbslanguageitems-moduleprovider.html#relativeSearchPaths-prop">relativeSearchPaths</a> property.</p>
<p>Here is a complete minimal example of a module provider. It just creates an empty module. If you put this item into the file <code>module-providers/mymodule/provider.qbs</code> in your project source directory, you will be able to successfully build a product which contains a dependency on the module <code>mymodule</code>.</p>
<pre class="cpp">

  import qbs<span class="operator">.</span>File
  import qbs<span class="operator">.</span>FileInfo
  import qbs<span class="operator">.</span>TextFile

  ModuleProvider {
      relativeSearchPaths: {
          var moduleDir <span class="operator">=</span> FileInfo<span class="operator">.</span>joinPaths(outputBaseDir<span class="operator">,</span> <span class="string">&quot;modules&quot;</span><span class="operator">,</span> name);
          File<span class="operator">.</span>makePath(moduleDir);
          var moduleFilePath <span class="operator">=</span> FileInfo<span class="operator">.</span>joinPaths(moduleDir<span class="operator">,</span> name <span class="operator">+</span> <span class="string">&quot;.qbs&quot;</span>);
          var moduleFile <span class="operator">=</span> <span class="keyword">new</span> TextFile(moduleFilePath<span class="operator">,</span> TextFile<span class="operator">.</span>WriteOnly);
          moduleFile<span class="operator">.</span>writeLine(<span class="string">&quot;Module {&quot;</span>);
          moduleFile<span class="operator">.</span>writeLine(<span class="string">&quot;}&quot;</span>);
          moduleFile<span class="operator">.</span>close();
          <span class="keyword">return</span> <span class="string">&quot;&quot;</span>;
      }
  }

</pre>
<!-- @@@ModuleProvider -->
<h2>Property Documentation</h2>
<!-- $$$name -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="name-prop">
<td class="tblQmlPropNode"><p>
<span class="name">name</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The name of the module provider.</p>
<p>This property is set by Qbs. For simple dependency names, it is the name of the dependency as specified in the <a href="qml-qbslanguageitems-depends.html">Depends</a> item. If the dependency name consists of multiple components, the value is the name up until (and including) the component that corresponds to the directory the provider was found in. For instance, if the dependency is <code>x.m1</code> and the provider was found in <code>module-providers/x/m1/provider.qbs</code>, then <code>name</code> is <code>x.m1</code>. If the provider was found in <code>module-providers/x/provider.qbs</code>, then <code>name</code> is <code>x</code>.</p>
</div></div><!-- @@@name -->
<br/>
<!-- $$$outputBaseDir -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="outputBaseDir-prop">
<td class="tblQmlPropNode"><p>
<span class="name">outputBaseDir</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The path under which the new modules should be created when <a href="qml-qbslanguageitems-moduleprovider.html#relativeSearchPaths-prop">relativeSearchPaths</a> is evaluated. The path is unique for the current provider in the given configuration.</p>
<p>This property is set by Qbs.</p>
</div></div><!-- @@@outputBaseDir -->
<br/>
<!-- $$$relativeSearchPaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="relativeSearchPaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">relativeSearchPaths</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property gets evaluated by Qbs to retrieve new search paths with which to re-attempt the module look-up.</p>
<p>It is here where you need to put the code that creates the new module files. Use the directory structure explained in <a href="custom-modules.html">Custom Modules and Items</a>. That is, the file for a module called <code>m</code> will be located in a directory <code>modules/m/</code>, anchored at <a href="qml-qbslanguageitems-moduleprovider.html#outputBaseDir-prop">outputBaseDir</a>.</p>
<p>The return value is the list of search paths required to find the new module, relative to <a href="qml-qbslanguageitems-moduleprovider.html#outputBaseDir-prop">outputBaseDir</a>. In most cases, only a single search path will be required, in which case a single-element list containing an empty string should be returned (or just the empty string, because of Qbs' auto-conversion feature).</p>
<p>The returned list can also be empty, which means that the module provider was not able to generate any modules in this environment.</p>
</div></div><!-- @@@relativeSearchPaths -->
<br/>
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="qml-qbslanguageitems-module.html">Module</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-parameter.html">Parameter</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
